//}eAp[^
static float Roughness=1.0;//\ʂ̑e
static float Metalic=0;//ۂ
static float Specular=0.0;//XyL
static float4 RMS=saturate(float4(Roughness,Metalic,Specular,1.0));

static float SSSRate=0.0;
static float3 SSSCircle=0.0;
static float4 SSSMat=saturate(float4(SSSCircle.r,SSSCircle.g,SSSCircle.b,SSSRate));


float time:TIME;

float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;


static float Si = Si10*0.1;


float CloudRateB : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "_x"; >;
static float CloudRate=CloudRateB;
float CloudPowerB : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "_x2"; >;
static float CloudPower=CloudPowerB;
float timeZB : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "_x"; >;
static float timeZ=timeZB*2.0-1.0;
float timeZ2B : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "Cx"; >;
static float timeZ2=timeZ2B*2.0-1.0;

float3 GroundColor : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "nʐF"; >;
float3 SkyColor : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "F"; >;
float3 ZenithColor : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "VF"; >;
float3 CloudColor : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "_F"; >;
float3 SeaColor : CONTROLOBJECT < string name = "KrSky2ConforMMD.pmx"; string item = "CF"; >;
static float2 timeT = time*0.01*(timeZ*180.0 / 3.14);
static float2 timeT2 = time*0.004*(timeZ2*180.0 / 3.14);






float4 ClearColor = { 0, 0, 0, 0.0 };
float ClearDepth = 0.0;
shared texture2D AlbedoSKrMRTMap	: RenderColorTarget ;
shared texture2D NormalDepthKrMRTMap	: RenderColorTarget ;
shared texture2D MaterialAKrMRTMap	: RenderColorTarget ;
shared texture2D MaterialBKrMRTMap	: RenderColorTarget ;
shared texture2D ZBufferKrMRT	: RenderDepthStencilTarget ;


// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;
static float3 CenterPos = WorldMatrix._41_42_43;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;


float3   LightDirection   : DIRECTION < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*1.6;


float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

static float3 MColor2= MaterialEmmisive+MaterialAmbient;
static float3 MColor=pow(MColor2,max(1.0,SpecularPower*0.01));

// eNX`ގ[tl
float4   TextureAddValue   : ADDINGTEXTURE;
float4   TextureMulValue   : MULTIPLYINGTEXTURE;
float4   SphereAddValue    : ADDINGSPHERETEXTURE;
float4   SphereMulValue    : MULTIPLYINGSPHERETEXTURE;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

texture2D CloudMap <
	string ResourceName = "CloudB.png";
	int MipLevels = 0;
>;
sampler CloudSamp = sampler_state {
	texture = <CloudMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float4 ScreenTex: TEXCOORD3;
	float3 Normal   : TEXCOORD4;
	float3 Eye2     : TEXCOORD5;
	float3 PosW2    : TEXCOORD6;
	float4 Pos2    : TEXCOORD7;
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos2 = Pos;

	Out.PosW = mul(Pos, WorldMatrix);

	Out.Normal =Normal;// normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix).xyz;
	Out.ScreenTex = Out.Pos;
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;
	Out.PosW2=Out.PosW.xyz-normalize(Out.Eye2)*dot(normalize(Out.Eye2),dot(float3(0.0,-1.0,0.0),Out.PosW.xyz)*normalize(Out.PosW.xyz))*0.8;
	
	return Out;
}


struct OUTPUT_PS {
	float4 AlbedoS : COLOR0;
	float4 NormalDepth    : COLOR1;
	float4 MaterialA    : COLOR2;
	float4 MaterialB    : COLOR3;
};

// sNZVF[_
OUTPUT_PS Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	OUTPUT_PS PSOut;


	float4 Color = 1.0;
	IN.Pos2.xyz*=10/IN.Pos2.w;
	float SkyRate=pow(1.0-abs(IN.Normal.y),2);
	float ZenithRate =abs(IN.Normal.y);
	
	Color.rgb =SkyColor;
	Color.rgb = lerp(Color.rgb, ZenithColor, ZenithRate);


	//Color.rgb += 50.0 / length(IN.PosW.xyz/Si + LightDirection * 5000-CenterPos);
	float3 SunColor=50.0 / length(IN.PosW.xyz/Si + LightDirection * 5000-CenterPos);
	float3 SunColor2=1000.0 / length(IN.PosW.xyz/Si + LightDirection * 5000-CenterPos);
	Color.rgb += SunColor+min(0.75,SunColor*10*(1.0/(length(LightDirection-CameraDirection)+0.5)));

	//Color.rgb += saturate(SunColor2*5)*0.3;
	
	//Color.rgb +=pow(saturate(dot(normalize(mul(IN.Normal,(float3x3)WorldMatrix)),LightDirection)),1024);
	float NYRimRate=1.05- pow(IN.Normal.y,1.0/8);
	float2 XZTex=IN.Pos2.xz*(1.0/(length(IN.Pos2.xz)*0.0001+1.0))*3;

	float CloudRate2 = CloudRate*saturate(SkyRate*0.5 + 0.5 - ZenithRate*0.25);
	float2 CloudTex = XZTex*0.0002*NYRimRate;
	float2 CloudTex2 = XZTex*0.00002*NYRimRate;
	float CloudRateC = tex2D(CloudSamp, CloudTex*0.5+timeT)+CloudPower;
	CloudRateC *= tex2D(CloudSamp, CloudTex + timeT)+CloudPower;
	CloudRateC =pow(CloudRateC,1.0/2);
	CloudRateC -= tex2D(CloudSamp, CloudTex2 + timeT)/(1.0+CloudRate*2)*(1.0-CloudPower);
	float CloudRateCB = saturate(tex2D(CloudSamp, CloudTex*0.2 + timeT*0.1))+CloudPower;

	float CloudRate2A = saturate(saturate(pow(CloudRate2*4,8))*CloudRateC*CloudRateCB);
	//CloudRate2A =pow(CloudRate2A,1.0/2);
	float CDRate = CloudRateC;// *(1.0 - CloudRateCB*0.5);

	//float CloudDarken = lerp(CDRate*0.5 + 0.5, 0.7 - CDRate, saturate(dot(LightDirection, IN.Normal)))*(tex2D(CloudSamp, CloudTex2*0.6 + timeT)*0.1+0.9);

	//float3 CloudColor2 = lerp(pow(CloudColor*0.8, 4),CloudColor,saturate(CloudDarken*0.5+0.5));


	float3 CloudDBVec=normalize(IN.PosW.xyz/Si + LightDirection * 5000-CenterPos)*saturate(distance(LightDirection, IN.Normal))*200;
	float2 CloudTexDar = (XZTex+CloudDBVec.xz)*0.0002*NYRimRate;
	float2 CloudTex2Dar = (XZTex+CloudDBVec.xz)*0.00002*NYRimRate;
	float CloudRateCDar = tex2D(CloudSamp, CloudTexDar*0.5+timeT)+CloudPower;
	CloudRateCDar *= tex2D(CloudSamp, CloudTexDar + timeT)+CloudPower;
	CloudRateCDar =pow(CloudRateCDar,1.0/2);
	CloudRateCDar-= tex2D(CloudSamp, CloudTex2Dar + timeT)/(1.0+CloudRate*2)*(1.0-CloudPower);
	float CloudRateCBDar = saturate(tex2D(CloudSamp, CloudTexDar*0.2 + timeT*0.1))+CloudPower;

	float CloudRate2Dar = saturate(saturate(pow(CloudRate2*4,8))*CloudRateCDar *CloudRateCBDar) ;
	//CloudRate2Dar =pow(CloudRate2Dar,1.0/2);

	float CloudDarken = saturate((CloudRate2A-CloudRate2Dar)*pow(-CloudRate2A+1.0,1.0/2));

	CloudDarken = saturate(CloudDarken+saturate(pow(dot(LightDirection, IN.Normal),3)));

	float3 CloudColor2 = lerp(CloudColor,pow(CloudColor*0.6, 4),CloudDarken);


	//CloudRate2 = pow(CloudRate2A, CloudPower);

	
	
	
	Color.rgb = lerp(Color.rgb, CloudColor2, saturate(CloudRate2A));
	
	float SeaTex=tex2D(CloudSamp, IN.PosW2.xz*0.001 + timeT2);
	SeaTex*=(SeaTex*0.75+0.25)*tex2D(CloudSamp, IN.PosW2.xz*0.01 + timeT2+sin(timeT2));
	SeaTex=(SeaTex*0.75+0.25)*(tex2D(CloudSamp, IN.PosW2.xz*0.0001 + timeT2*0.1)*0.5+0.5);
	float3 SeaColor2=lerp(SeaColor,pow(SeaColor,1.2),SeaTex);
	
	
	
	float SeaTex2=tex2D(CloudSamp, IN.PosW2.xz*0.002 + timeT2+float2((IN.PosW2.z*0.03-sin(timeT.x)+10),sin(IN.PosW2.x*0.03+sin(timeT.x)+100))*0.02);
	
	SeaColor2=lerp(SeaColor2,(SeaColor2)+0.05,saturate(pow((0.5-SeaTex2)*2,16)));
	float SeaRate2=saturate(-IN.PosW.y*0.01);
	
	Color.rgb = lerp(Color.rgb, SeaColor2, saturate(SeaRate2));
	
	Color.rgb=lerp(GroundColor,Color.rgb, saturate(pow(IN.Normal.y,1.0/2.0)));
	/////////////////////////////////////////////////////////////////////////////////
	PSOut.AlbedoS.rgb = Color.rgb;
	PSOut.AlbedoS.a=max(0.0,SpecularPower-100.0);

	/////////////////////////////////////////////////////////////////////////////////
	float3 Normal = normalize(mul(IN.Normal, (float3x3)WorldMatrix));
	Normal=Normal*VFace;
	PSOut.NormalDepth.rgb = Normal.rgb;
	PSOut.NormalDepth.a = IN.Eye.z;

	/////////////////////////////////////////////////////////////////////////////////
	PSOut.MaterialA.rgba =RMS;
	PSOut.MaterialB.rgba =SSSMat;
	/////////////////////////////////////////////////////////////////////////////////
	return PSOut;
}

technique TechDF < string MMDPass = "object"; bool UseTexture = false;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"


"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"

;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}

}



technique TechDFS < string MMDPass = "object_ss"; bool UseTexture = false;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"

"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"
;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique TechDFTX < string MMDPass = "object"; bool UseTexture = true;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"


"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"

;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}

}



technique TechDFSTX < string MMDPass = "object_ss"; bool UseTexture = true;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"

"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"
;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}

}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}

///////////////////////////////////////////////////////////////////////////////////////////////