///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////




static float AABlurScale=0.5;
static float AAScale=0.0;

#define SAMPNUMSSAO2 32
#define SAMPNUMS 16
#define SAMPNUMS2 8
#define SAMPNUMSS 16
#define SAMPNUMSS2 8
#define SAMPNUMAA 16

#define SAMPNUMSSS2 8

static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
//e

 float3 SkyColor1
 <
   string UIName = "";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float3 UIMin = 0.00;
   float3 UIMax = 1.00;
 > = float3(0.05,0.05,0.05);
static float3 SkyColor=(SkyColor1)*LightColor;

 float3 GroundColor1
 <
   string UIName = "nʊ";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float3 UIMin = 0.00;
   float3 UIMax = 1.00;
 > = float3(0.05,0.05,0.05);
static float3 GroundColor=(GroundColor1)*LightColor;

 float SRainRate 
 <
   string UIName = "Jގ";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
 > = float(0.0);

///////////////////////////////////////////////////////////////////////////////////
float4x4 SMat: CONTROLOBJECT < string name = "MainSystem_MMM.x"; >;
static float3 SPos = float3(SMat._41, SMat._42, SMat._43);
float ShSi2 : CONTROLOBJECT < string name = "MainSystem_MMM.x"; string item = "Si"; >;

static float ShSi = ShSi2*0.1;

float3    LightDirL1   : DIRECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;

static float3 PosL = SPos  - LightDirection * 3000;


float4 GetLightPos(float3 WPos)
{

	float LYZFlag = step(0.999, pow(LightDirection.y, 2));

	float3 LCrossX = normalize(cross(LightDirection, float3(0.0, LYZFlag, 1.0 - LYZFlag)));

	float3 LCrossY = normalize(cross(LightDirection, LCrossX));

	float4 XYZ = 0;

	float3 WLL=(WPos - PosL);
	XYZ.z = dot(LightDirection, WLL);
	XYZ.x = dot(LCrossX, WLL);
	XYZ.y = dot(LCrossY, WLL);

	XYZ.xy /= 256 * ShSi;


	XYZ.z = (XYZ.z - 500) / (6000 - 500);


	XYZ.w = 1;
	return XYZ;
}





shared texture KrSSLiteShaMapRT: OFFSCREENRENDERTARGET <
	string Description = "LS";
	int Width =4096;
	int Height =4096;
	string Format = "R32F";
	float4 ClearColor = { 10000, 0, 0, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = false;//true;
	int Miplevels = 1;
	string DefaultEffect =
		"self = hide;"
		"* = ShadowMap_MMM/ShadowMap.fx;";
>;
sampler2D KrSSLiteShaSamp = sampler_state {
	texture = <KrSSLiteShaMapRT>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
static float2 SSampStep =0.15 / 4096;

///////////////////////////////////////////////////////////////////////////////////
//e܂1

float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1, 1) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);



shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET <
	float2 ViewPortRatio = { 1.0,1.0 };
string Description = "ގ蓖1";
string Format = "A32B32G32R32F";
float4 ClearColor = { 0, 0, 0, 0 };
float ClearDepth = 1.0;
bool AntiAlias = false;
int Miplevels = 1;
string DefaultEffect =
"self = hide;"
"* =Material_MMM/Base/Material.fx;";
>;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



shared texture2D WPosKrMapB : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMapB>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D NormalDepthKrMapB : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMapB>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D AlbedoMapB : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMapB>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMapB : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D MatASamp = sampler_state {
	texture = <MatAMapB>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMapB : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMapB>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D WPosKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D WPosSampA = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D NormalDepthSampA = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D AlbedoSampA = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D MatASampA = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D LumiSampA = sampler_state {
	texture = <LumiMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture2D DirShadowAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowASamp = sampler_state {
	texture = <DirShadowAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D DirShadowBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowBSamp = sampler_state {
	texture = <DirShadowBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D PLDiffuseMap : RENDERCOLORTARGET;
sampler2D PLDiffuseSamp = sampler_state {
	texture = <PLDiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D PLSpecularMap : RENDERCOLORTARGET;
sampler2D PLSpecularSamp = sampler_state {
	texture = <PLSpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};
shared texture2D DiffuseMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D DiffuseSamp = sampler_state {
	texture = <DiffuseMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D SSSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSSSamp = sampler_state {
	texture = <SSSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D SpecularMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SpecularSamp = sampler_state {
	texture = <SpecularMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D TotalKrSSLMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D TotalKrSSLSamp = sampler_state {
	texture = <TotalKrSSLMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D DepthBuffer2 : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);

	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_MatA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	float3 Mat = fmod(trunc(abs(Color.rgb))*0.01,1.0);
	float3 Mat2 = fmod(trunc(abs(Color.rgb))*0.01,10.0)*0.1;
	float4 RMSS = float4(Mat,Mat2.x);

	return RMSS;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_ND(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(MaterialKrSSLSamp, Tex);
	ND.rgb = normalize(fmod(ND.rgb, 1.0));
	ND.a=abs(ND.a);
	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Albedo(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Lumi(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.rgb=normalize(Color.rgb)*max(0.0,length(Color.rgb)-2);
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_PosW(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = 1.0;
	float Depth = abs(tex2D(MaterialKrSSLSamp, Tex).a);

	Depth=lerp(10000,Depth,step(0.00001,Depth));

	float2 PPos = (Tex - 0.5) * float2(2.0, -2.0);
	float3 VPos = float3(PPos.xy * scaleProj, 1) * Depth;
	Color.rgb = mul(float4(VPos, 1), InvViewMatrix).xyz;
	Color.a = distance(Color.rgb,CameraPosition);// Depth;


	return Color;
}
float GetAORate(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale)
{
	float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO2; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);
		float VG = saturate(1.0 - distance(normalize(Gap), Normal.xyz)*5);

		Rate += VG;
	}
	Rate = saturate(Rate/SAMPNUMSSAO2*16);
	return Rate;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float4 WPos = tex2D(WPosSamp, Tex);
	WPos.a = 1.0;
	float3 Normal = ND.rgb;
	float Depth = ND.a;
	float4 Color = 1.0;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	
	Color.r = saturate((dot(LightDir, Normal)) * 80);
	
	float4 ZCalcTex= GetLightPos(WPos.xyz);

	// eNX`Wɕϊ
	ZCalcTex /= ZCalcTex.w;
	float ZTexLength=length(ZCalcTex.xy);
	float2 TransTexCoord;
	TransTexCoord.x = (1.0f + ZCalcTex.x)*0.5f;
	TransTexCoord.y = (1.0f - ZCalcTex.y)*0.5f;

	
	float SCor =length(scaleProj)+min(10.0, Depth*0.002);
	float SCorS =9000.0;
	
	float SSRate = saturate(max(ZCalcTex.z - tex2D(KrSSLiteShaSamp, TransTexCoord).a, 0.0f) *SCorS - SCor);
	float2 SSampStep2=SSampStep;
	
	
	[unroll]
	for (int ix =-SAMPNUMS2; ix <= SAMPNUMS2; ix++) {
	for (int iy = -SAMPNUMS2; iy <= SAMPNUMS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = TransTexCoord+ SSampStep2*AddTexB;
	
		float SColor= tex2D(KrSSLiteShaSamp, Stex).r;
		SSRate+=saturate(max(ZCalcTex.z - SColor, 0.0f)*SCorS - SCor);

	}
	}
	
	SSRate = 1.0 - saturate(SSRate / pow(SAMPNUMS2*2 + 1,2)*4);

	float TexFlag=saturate(pow((length(TransTexCoord.xy-0.5))*2,2)-0.75)*4;

	Color.r *=  saturate(SSRate+TexFlag);
	
	float LSSize=0.02;//(0.02 + max(0.0,Depth*0.002 - 0.5));
	float3 L2Normal = normalize(lerp(-LightDirection, Normal , 0.1));
	float3 DOPos = WPos.xyz + L2Normal*LSSize;
	float4 DOTex = mul(float4(DOPos, 1.0), ViewProjMatrix);
	DOTex.x = (1.0f + DOTex.x / DOTex.w) * 0.5f;
	DOTex.y = (1.0f - DOTex.y / DOTex.w) * 0.5f;
	float2 DOTexAdd = DOTex.xy - Tex.xy;
	float SRate = GetAORate(L2Normal, Tex, DOTexAdd, WPos, 0.0);
	
	Color.r*=1.0-SRate;//*(1.0-RFlag2);
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	
	float2 STexSampA = SampStep * ViewportSize.y/1080;///min(10,max(1.0,Depth*0.1));
	float2 stexAdd = 0;
	float FColor = tex2D(DirShadowASamp, Tex).r;
	float VGT = 1.0;
	
	[unroll]
	for (int ix =-SAMPNUMSS2; ix <= SAMPNUMSS2; ix++) {
	for (int iy = -SAMPNUMSS2; iy <= SAMPNUMSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;
		
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, Normal.xyz));
		VG *=saturate(1.0-distance(AONormal.a,Depth)*0.1);

		float SColor2 = tex2D(DirShadowASamp, Stex).r;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	FColor /=max(1.0,VGT);	
	Color.r=saturate(FColor);
	
	
	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////
/*
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float A = 1 - 0.5*(RoughnessA / (RoughnessA + 0.33));
	float B = 0.45*(RoughnessA / (RoughnessA + 0.09));

	float dotEN = saturate(dot(EyeVec, Normal));
	float dotLN = saturate(dot(LightDir, Normal));

	float alpha = max(acos(dotEN), acos(dotLN));
	float beta = min(acos(dotEN), acos(dotLN));

	float D = sin(alpha) * tan(beta);

	float gamma = dot(normalize(EyeVec - Normal * dotEN), normalize(LightDir - Normal * dotLN));
	float C = max(0, gamma);
	//float4  OrNer = max(0.0f, dot(Normal, l)) * (A + B * C * D);

	float Diffuse = dotLN *(A + B * C * D);
	return Diffuse;
}
*/
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float dotLN = saturate(dot(LightDir, Normal));
	float Diffuse = dotLN;
	return Diffuse;
}


float4 PS_Diffuse(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	float DiffuseRate=GetDif(Normal, LightDir, EyeVec, RoughnessA);
	float Dif=DiffuseRate*ShadowRate.r;
	float3 TotalDiffuseColor=Dif*LightColor/ 3.141592;
	
	TotalDiffuseColor+=tex2D(PLDiffuseSamp,Tex);
	

	float3 EnvColor=SkyColor*saturate(dot(normalize(LightDir*0.3+float3(0.0,1.0,0.0)),Normal)*0.5+0.5)+GroundColor*saturate(dot(normalize(-LightDir*0.3+float3(0.0,-1.0,0.0)),Normal)*0.5+0.5);

	TotalDiffuseColor+=EnvColor;

	Color.rgb=TotalDiffuseColor;
	
	
	return Color;
}




float4 PS_SSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	float3 SSSCircle=normalize(pow(Albedo.rgb,16))*0.8;
	float3 SSSColor=normalize(pow(Albedo.rgb,16));
	float SSSRate= RMSS.a;
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////

	
	
	float3 TotalDiffuse=tex2D(DiffuseSamp, Tex);
	float3 TotalDiffuseSSS=TotalDiffuse;
	float2 SSSSampStep = SampStep2 / max(1.0, min(100.0, Depth*scaleProj))*30;
	
	
	
	float SSSRateS = 0.0;
	float2 STexSampA =SSSSampStep*SSSCircle.r;
	float TotalDiffuseSSS1 = 0;
	float SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).r;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.r += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.r=lerp(TotalDiffuse.r,TotalDiffuseSSS.r / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.g;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).g;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.g += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.g=lerp(TotalDiffuse.g,TotalDiffuseSSS.g / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.b;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).b;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.b += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.b=lerp(TotalDiffuse.b,TotalDiffuseSSS.b / SSSRateS,step(0.00001,SSSRateS));
	
	

	TotalDiffuse = lerp(TotalDiffuse, TotalDiffuseSSS, saturate(SSSRate*SSSColor));
	
	
	Color.rgb =TotalDiffuse*(1.0-Metalic);

	
	return Color;
}


float GetSp(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA, float F0)
{
	float3 HalfVec = normalize(EyeVec + LightDir);
	float DotNL = max(0.00000001, saturate(dot(Normal, LightDir)));
	float DotNE = max(0.00000001, saturate(dot(Normal, EyeVec)));
	float DotNH = max(0.00000001, saturate(dot(Normal, HalfVec)));
	float DotEH = max(0.00000001, saturate(dot(EyeVec, HalfVec)));
	float DotLH = max(0.00000001, saturate(dot(LightDir, HalfVec)));

	float D = pow(RoughnessA, 2) / (3.14159265*pow(pow(DotNH, 2)*(pow(RoughnessA, 2) - 1) + 1, 2));
	float F = F0 + (1 - F0)*pow(1.0 - DotEH, 5);
	float G = min(1.0, min(2 * DotNH*DotNE / DotEH, 2 * DotNH*DotNL / DotEH));
	float Specular = F*D*G / (4 * DotNE*DotNL);// +0.0001);

	Specular = max(0.0, min(2.0, Specular));

	return Specular;
}




float4 PS_Specular(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SSSSamp,Tex);
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float F0 = lerp(F0Def, F0MetalDef, saturate(Metalic+(1.0-Roughness)*0.05));
	float Specular=lerp(RMSS.b,1.0,SRainRate);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	
	
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	
	float3 SpecularColor =  GetSp(Normal, LightDir, EyeVec, RoughnessA, F0)*LightColor* SpecularAlbedo*ShadowRate.r;




	
	
	float ENDotR=max(0.0,2.0-dot(EyeVec,ND.xyz));
	
	
	
	
	SpecularColor+=tex2D(PLSpecularSamp,Tex)* SpecularAlbedo;
	
	
	Color.rgb=SpecularColor;

	return Color;
}

float4 PS_TotalKrSSL(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SpecularSamp,Tex);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	Color.rgb +=tex2D(SSSSamp,Tex)*Albedo.rgb;

	Color.rgb = pow(Color.rgb, 1.0/2.2);

	Color.rgb = min(5.0,max(0.0,Color.rgb));
	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_MatAA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(MatASamp,Tex);
	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_NDA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(NormalDepthSamp,Tex);
	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_LumiA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =  tex2D(LumiSamp,Tex);
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_PosWA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(WPosSamp,Tex);
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_AlbedoA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(AlbedoSamp, Tex);
	return Color;
}
///

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Draw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp,Tex);


	return Color;
}

technique FILTER <
	string Script =

	"RenderColorTarget0=MatAMapB;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=MatA;"

	"RenderColorTarget0=WPosKrMapB;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=PosW;"

	"RenderColorTarget0=NormalDepthKrMapB;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=ND;"
	
	"RenderColorTarget0=AlbedoMapB;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Albedo;"
	
	"RenderColorTarget0=LumiMapB;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Lumi;"
	
	"RenderColorTarget0=DirShadowAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowA;"
	
	"RenderColorTarget0=DirShadowBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowB;"

	"RenderColorTarget0=DiffuseMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Diffuse;"

	"RenderColorTarget0=SSSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSS;"
	
	"RenderColorTarget0=SpecularMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Specular;"
	
	"RenderColorTarget0=TotalKrSSLMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=TotalKrSSL;"

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=MatAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=MatAA;"

	"RenderColorTarget0=WPosKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=PosWA;"

	"RenderColorTarget0=NormalDepthKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=NDA;"
	
	"RenderColorTarget0=AlbedoMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=AlbedoA;"
	
	"RenderColorTarget0=LumiMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=LumiA;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw;"
	;

> {
	pass MatA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_MatA();
	}
	pass PosW < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_PosW();
	}
	pass ND < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_ND();
	}
	pass Albedo < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Albedo();
	}
	pass Lumi < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Lumi();
	}
	pass DirShadowA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowA();
	}
	pass DirShadowB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowB();
	}
	pass Diffuse < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Diffuse();
	}
	pass SSS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSS();
	}
	pass Specular < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Specular();
	}
	pass TotalKrSSL < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_TotalKrSSL();
	}
	pass MatAA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_MatAA();
	}
	pass PosWA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_PosWA();
	}
	pass NDA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_NDA();
	}
	pass AlbedoA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_AlbedoA();
	}
	pass LumiA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_LumiA();
	}
	pass Draw < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Draw();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
